'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var reactAdmin = require('react-admin');
var auth = require('@aws-amplify/auth');
var api = require('@aws-amplify/api');
var storage = require('@aws-amplify/storage');
var uuid = require('uuid');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || from);
}

var defaultOptions$1 = {
    authGroups: [],
};
var AuthProvider = /** @class */ (function () {
    function AuthProvider(options) {
        var _this = this;
        this.login = function (_a) {
            var username = _a.username, password = _a.password, clientMetadata = _a.clientMetadata;
            return auth.Auth.signIn(username, password, clientMetadata);
        };
        this.logout = function () {
            return auth.Auth.signOut();
        };
        this.checkAuth = function () { return __awaiter(_this, void 0, void 0, function () {
            var session, userGroups, _i, userGroups_1, group;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, auth.Auth.currentSession()];
                    case 1:
                        session = _a.sent();
                        if (this.authGroups.length === 0) {
                            return [2 /*return*/];
                        }
                        userGroups = session.getAccessToken().decodePayload()["cognito:groups"];
                        if (!userGroups) {
                            throw new Error("Unauthorized");
                        }
                        for (_i = 0, userGroups_1 = userGroups; _i < userGroups_1.length; _i++) {
                            group = userGroups_1[_i];
                            if (this.authGroups.includes(group)) {
                                return [2 /*return*/];
                            }
                        }
                        throw new Error("Unauthorized");
                }
            });
        }); };
        this.checkError = function () {
            return Promise.resolve();
        };
        this.getPermissions = function () { return __awaiter(_this, void 0, void 0, function () {
            var session, groups;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, auth.Auth.currentSession()];
                    case 1:
                        session = _a.sent();
                        groups = session.getAccessToken().decodePayload()["cognito:groups"];
                        return [2 /*return*/, groups ? Promise.resolve(groups) : Promise.reject()];
                }
            });
        }); };
        this.authGroups = (options === null || options === void 0 ? void 0 : options.authGroups) || defaultOptions$1.authGroups;
    }
    return AuthProvider;
}());

var Pagination = /** @class */ (function () {
    function Pagination() {
    }
    Pagination.getNextToken = function (querySignature, page) {
        var _a;
        // Initialize the array of tokens
        if (!this.tokens[querySignature]) {
            this.tokens[querySignature] = [];
        }
        if (page !== 1 &&
            typeof this.tokens[querySignature][page - 1] === "undefined") {
            return undefined;
        }
        return (_a = this.tokens[querySignature][page - 1]) !== null && _a !== void 0 ? _a : null;
    };
    Pagination.saveNextToken = function (nextToken, querySignature, page) {
        // Initialize the array of tokens
        if (!this.tokens[querySignature]) {
            this.tokens[querySignature] = [];
        }
        this.tokens[querySignature][page] = nextToken;
    };
    Pagination.tokens = {};
    return Pagination;
}());

var AdminQueries = /** @class */ (function () {
    function AdminQueries() {
    }
    AdminQueries.listCognitoUsers = function (params) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var _c, getUser, listUsersInGroup, userData, user, e_1, queryName, queryVariables, _d, page, perPage, querySignature, token, queryResult, e_2, users, nextToken, total;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        _c = params.filter, getUser = _c.getUser, listUsersInGroup = _c.listUsersInGroup;
                        if (!getUser) return [3 /*break*/, 4];
                        _e.label = 1;
                    case 1:
                        _e.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, AdminQueries.get("/getUser", {
                                username: getUser.username,
                            })];
                    case 2:
                        userData = _e.sent();
                        user = AdminQueries.parseUser(userData);
                        return [2 /*return*/, {
                                data: [user],
                                total: 1,
                            }];
                    case 3:
                        e_1 = _e.sent();
                        // Returns 400 when user not found
                        if (((_a = e_1.response) === null || _a === void 0 ? void 0 : _a.status) !== 400) {
                            throw e_1;
                        }
                        return [2 /*return*/, {
                                data: [],
                                total: 0,
                            }];
                    case 4:
                        queryName = "listUsers";
                        queryVariables = {};
                        // Second filter listUsersInGroup
                        // Returns Cognito users by group
                        if (listUsersInGroup) {
                            queryName = "listUsersInGroup";
                            queryVariables = {
                                groupname: listUsersInGroup.groupname,
                            };
                        }
                        _d = params.pagination, page = _d.page, perPage = _d.perPage;
                        querySignature = JSON.stringify({
                            queryName: queryName,
                            queryVariables: queryVariables,
                            perPage: perPage,
                        });
                        token = Pagination.getNextToken(querySignature, page);
                        // Checks if page requested is out of range
                        if (typeof token === "undefined") {
                            return [2 /*return*/, {
                                    data: [],
                                    total: 0,
                                }]; // React admin will redirect to page 1
                        }
                        queryResult = { Users: [], NextToken: undefined };
                        _e.label = 5;
                    case 5:
                        _e.trys.push([5, 7, , 8]);
                        return [4 /*yield*/, AdminQueries.get("/" + queryName, __assign(__assign({}, queryVariables), { limit: perPage, token: token }))];
                    case 6:
                        queryResult = _e.sent();
                        return [3 /*break*/, 8];
                    case 7:
                        e_2 = _e.sent();
                        // Returns 400 when group not found
                        if (!listUsersInGroup || ((_b = e_2.response) === null || _b === void 0 ? void 0 : _b.status) !== 400) {
                            throw e_2;
                        }
                        return [3 /*break*/, 8];
                    case 8:
                        users = queryResult.Users.map(AdminQueries.parseUser);
                        nextToken = queryResult.NextToken || null;
                        // Saves next token
                        Pagination.saveNextToken(nextToken, querySignature, page);
                        total = (page - 1) * perPage + users.length;
                        if (nextToken) {
                            total++; // Tells react admin that there is at least one more page
                        }
                        return [2 /*return*/, {
                                data: users,
                                total: total,
                            }];
                }
            });
        });
    };
    AdminQueries.listCognitoGroups = function (params) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var listGroupsForUser, queryName, queryVariables, _b, page, perPage, querySignature, token, queryResult, e_3, groups, nextToken, total;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        listGroupsForUser = params.filter.listGroupsForUser;
                        queryName = "listGroups";
                        queryVariables = {};
                        // Filter listGroupsForUser
                        // Returns Cognito groups by user
                        if (listGroupsForUser) {
                            queryName = "listGroupsForUser";
                            queryVariables = {
                                username: listGroupsForUser.username,
                            };
                        }
                        _b = params.pagination, page = _b.page, perPage = _b.perPage;
                        querySignature = JSON.stringify({
                            queryName: queryName,
                            queryVariables: queryVariables,
                            perPage: perPage,
                        });
                        token = Pagination.getNextToken(querySignature, page);
                        // Checks if page requested is out of range
                        if (typeof token === "undefined") {
                            return [2 /*return*/, {
                                    data: [],
                                    total: 0,
                                }]; // React admin will redirect to page 1
                        }
                        queryResult = { Groups: [], NextToken: undefined };
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, AdminQueries.get("/" + queryName, __assign(__assign({}, queryVariables), { limit: perPage, token: token }))];
                    case 2:
                        queryResult = _c.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _c.sent();
                        // Returns 400 when user not found
                        if (!listGroupsForUser || ((_a = e_3.response) === null || _a === void 0 ? void 0 : _a.status) !== 400) {
                            throw e_3;
                        }
                        return [3 /*break*/, 4];
                    case 4:
                        groups = queryResult.Groups.map(AdminQueries.parseGroup);
                        nextToken = queryResult.NextToken || null;
                        // Saves next token
                        Pagination.saveNextToken(nextToken, querySignature, page);
                        total = (page - 1) * perPage + groups.length;
                        if (nextToken) {
                            total++; // Tells react admin that there is at least one more page
                        }
                        return [2 /*return*/, {
                                data: groups,
                                total: total,
                            }];
                }
            });
        });
    };
    AdminQueries.getCognitoUser = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var userData, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, AdminQueries.get("/getUser", {
                            username: params.id,
                        })];
                    case 1:
                        userData = _a.sent();
                        user = AdminQueries.parseUser(userData);
                        return [2 /*return*/, {
                                data: user,
                            }];
                }
            });
        });
    };
    AdminQueries.getManyCognitoUsers = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var users, _i, _a, id, userData, user, e_4;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        users = [];
                        _i = 0, _a = params.ids;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 6];
                        id = _a[_i];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, AdminQueries.get("/getUser", {
                                username: id,
                            })];
                    case 3:
                        userData = _b.sent();
                        user = AdminQueries.parseUser(userData);
                        users.push(user);
                        return [3 /*break*/, 5];
                    case 4:
                        e_4 = _b.sent();
                        console.log(e_4);
                        return [3 /*break*/, 5];
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/, {
                            data: users,
                        }];
                }
            });
        });
    };
    AdminQueries.parseUser = function (user) {
        var Username = user.Username, Attributes = user.Attributes, UserAttributes = user.UserAttributes, fields = __rest(user, ["Username", "Attributes", "UserAttributes"]);
        var attributes = AdminQueries.parseAttributes(Attributes || UserAttributes);
        return __assign(__assign(__assign({}, fields), attributes), { id: Username });
    };
    AdminQueries.parseGroup = function (group) {
        var GroupName = group.GroupName, fields = __rest(group, ["GroupName"]);
        return __assign(__assign({}, fields), { id: GroupName });
    };
    AdminQueries.parseAttributes = function (attributes) {
        return attributes.reduce(function (attributes, attribute) {
            var _a;
            var Name = attribute.Name, Value = attribute.Value;
            return __assign(__assign({}, attributes), (_a = {}, _a[Name] = Value, _a));
        }, {});
    };
    AdminQueries.get = function (path, params) {
        return __awaiter(this, void 0, void 0, function () {
            var init, _a;
            var _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _b = {
                            queryStringParameters: params
                        };
                        _c = {
                            "Content-Type": "application/json"
                        };
                        _a = "";
                        return [4 /*yield*/, auth.Auth.currentSession()];
                    case 1:
                        init = (_b.headers = (_c.Authorization = _a + (_d.sent())
                            .getAccessToken()
                            .getJwtToken(),
                            _c),
                            _b);
                        return [4 /*yield*/, api.API.get("AdminQueries", path, init)];
                    case 2: return [2 /*return*/, _d.sent()];
                }
            });
        });
    };
    return AdminQueries;
}());

var sortOperators = ["eq", "le", "lt", "ge", "gt", "beginsWith"];
var bannedKeyNames = ["sortDirection", "limit", "nextIndex"];
var Filter = /** @class */ (function () {
    function Filter() {
    }
    Filter.getQueryName = function (queries, filter) {
        if (!this.isObjectOfLength(filter, 1)) {
            return null;
        }
        // The filter unique field is the query name
        var queryName = Object.keys(filter)[0];
        if (!queries[queryName]) {
            console.log("Could not find query " + queryName);
            throw new Error("Data provider error");
        }
        return queryName;
    };
    Filter.getQueryVariables = function (filter) {
        var _a, _b;
        if (!this.isObjectOfLength(filter, 1)) {
            return null;
        }
        var queryParams = Object.values(filter)[0];
        for (var _i = 0, bannedKeyNames_1 = bannedKeyNames; _i < bannedKeyNames_1.length; _i++) {
            var bannedKeyName = bannedKeyNames_1[_i];
            delete queryParams[bannedKeyName];
        }
        // Case when there is only the hash key
        if (this.isObjectOfLength(queryParams, 1)) {
            var onlyParam = Object.values(queryParams)[0];
            if (this.isHashKeyValid(onlyParam)) {
                return queryParams;
            }
            return null;
        }
        // Case when there are the hash key and the sort key
        if (this.isObjectOfLength(queryParams, 2)) {
            var firstParam = Object.values(queryParams)[0];
            var secondParam = Object.values(queryParams)[1];
            if (this.isHashKeyValid(firstParam)) {
                if (this.isSortKeyValid(secondParam)) {
                    return queryParams;
                }
                return _a = {},
                    _a[Object.keys(queryParams)[0]] = firstParam,
                    _a;
            }
            if (this.isHashKeyValid(secondParam)) {
                if (this.isSortKeyValid(firstParam)) {
                    return queryParams;
                }
                return _b = {},
                    _b[Object.keys(queryParams)[1]] = secondParam,
                    _b;
            }
        }
        return null;
    };
    Filter.isObject = function (obj) {
        return obj !== null && typeof obj === "object";
    };
    Filter.isObjectOfLength = function (obj, length) {
        if (length === void 0) { length = 0; }
        if (!this.isObject(obj)) {
            return false;
        }
        return Object.keys(obj).length === length;
    };
    Filter.isString = function (str) {
        return typeof str === "string" && str !== "";
    };
    Filter.isHashKeyValid = function (key) {
        return this.isString(key) || typeof key === "number";
    };
    Filter.isSortKeyValid = function (obj) {
        if (!this.isObjectOfLength(obj, 1)) {
            return false;
        }
        var key = obj;
        if (!sortOperators.includes(Object.keys(key)[0])) {
            return false;
        }
        var keyInput = Object.values(key)[0];
        if (this.isHashKeyValid(keyInput)) {
            return true;
        }
        if (this.isObject(keyInput) && Object.keys(keyInput).length > 1) {
            for (var sortField in keyInput) {
                if (!this.isHashKeyValid(keyInput[sortField])) {
                    return false;
                }
            }
            return true;
        }
        return false;
    };
    return Filter;
}());

var defaultOptions = {
    authMode: api.GRAPHQL_AUTH_MODE.AMAZON_COGNITO_USER_POOLS,
    enableAdminQueries: false,
};
var DataProvider = /** @class */ (function () {
    function DataProvider(operations, options) {
        var _this = this;
        this.getList = function (resource, params) { return __awaiter(_this, void 0, void 0, function () {
            var filter, queryName, queryVariables, query, _a, page, perPage, querySignature, nextToken, queryData, total;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (this.enableAdminQueries && resource === "cognitoUsers") {
                            return [2 /*return*/, AdminQueries.listCognitoUsers(params)];
                        }
                        if (this.enableAdminQueries && resource === "cognitoGroups") {
                            return [2 /*return*/, AdminQueries.listCognitoGroups(params)];
                        }
                        filter = params.filter;
                        queryName = Filter.getQueryName(this.queries, filter);
                        queryVariables = Filter.getQueryVariables(filter);
                        if (!queryName || !queryVariables) {
                            // Default list query without filter
                            queryName = this.getQueryName("list", resource);
                        }
                        query = this.getQuery(queryName);
                        if (!queryVariables) {
                            queryVariables = {};
                        }
                        _a = params.pagination, page = _a.page, perPage = _a.perPage;
                        querySignature = JSON.stringify({
                            queryName: queryName,
                            queryVariables: queryVariables,
                            perPage: perPage,
                        });
                        nextToken = Pagination.getNextToken(querySignature, page);
                        // Checks if page requested is out of range
                        if (typeof nextToken === "undefined") {
                            return [2 /*return*/, {
                                    data: [],
                                    total: 0,
                                }]; // React admin will redirect to page 1
                        }
                        // Adds sorting if requested
                        if (params.sort.field === queryName) {
                            queryVariables["sortDirection"] = params.sort.order;
                        }
                        return [4 /*yield*/, this.graphql(query, __assign(__assign({}, queryVariables), { limit: perPage, nextToken: nextToken }))];
                    case 1:
                        queryData = (_b.sent())[queryName];
                        // Saves next token
                        Pagination.saveNextToken(queryData.nextToken, querySignature, page);
                        total = (page - 1) * perPage + queryData.items.length;
                        if (queryData.nextToken) {
                            total++; // Tells react admin that there is at least one more page
                        }
                        return [2 /*return*/, {
                                data: queryData.items,
                                total: total,
                            }];
                }
            });
        }); };
        this.getOne = function (resource, params) { return __awaiter(_this, void 0, void 0, function () {
            var queryName, query, queryData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.enableAdminQueries && resource === "cognitoUsers") {
                            return [2 /*return*/, AdminQueries.getCognitoUser(params)];
                        }
                        queryName = this.getQueryName("get", resource);
                        query = this.getQuery(queryName);
                        return [4 /*yield*/, this.graphql(query, { id: params.id })];
                    case 1:
                        queryData = (_a.sent())[queryName];
                        return [2 /*return*/, {
                                data: queryData,
                            }];
                }
            });
        }); };
        this.getMany = function (resource, params) { return __awaiter(_this, void 0, void 0, function () {
            var queryName, query, queriesData, _i, _a, id, queryData, e_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (this.enableAdminQueries && resource === "cognitoUsers") {
                            return [2 /*return*/, AdminQueries.getManyCognitoUsers(params)];
                        }
                        queryName = this.getQueryName("get", resource);
                        query = this.getQuery(queryName);
                        queriesData = [];
                        _i = 0, _a = params.ids;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 6];
                        id = _a[_i];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this.graphql(query, { id: id })];
                    case 3:
                        queryData = (_b.sent())[queryName];
                        queriesData.push(queryData);
                        return [3 /*break*/, 5];
                    case 4:
                        e_1 = _b.sent();
                        console.log(e_1);
                        return [3 /*break*/, 5];
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/, {
                            data: queriesData,
                        }];
                }
            });
        }); };
        this.getManyReference = function (resource, params) { return __awaiter(_this, void 0, void 0, function () {
            var _a, filter, id, pagination, sort, target, splitTarget, queryName;
            return __generator(this, function (_b) {
                _a = params.filter, filter = _a === void 0 ? {} : _a, id = params.id, pagination = params.pagination, sort = params.sort, target = params.target;
                splitTarget = target.split(".");
                // splitTarget is used to build the filter
                // It must be like: queryName.resourceID
                if (splitTarget.length === 2) {
                    if (!filter[splitTarget[0]]) {
                        filter[splitTarget[0]] = {};
                    }
                    filter[splitTarget[0]][splitTarget[1]] = id;
                }
                else {
                    queryName = this.getQueryNameMany("list", resource, target);
                    if (!filter[queryName]) {
                        filter[queryName] = {};
                    }
                    filter[queryName][target] = id;
                }
                return [2 /*return*/, this.getList(resource, { pagination: pagination, sort: sort, filter: filter })];
            });
        }); };
        this.create = function (resource, params) { return __awaiter(_this, void 0, void 0, function () {
            var queryName, query, queryData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        queryName = this.getQueryName("create", resource);
                        query = this.getQuery(queryName);
                        return [4 /*yield*/, this.graphql(query, { input: params.data })];
                    case 1:
                        queryData = (_a.sent())[queryName];
                        return [2 /*return*/, {
                                data: queryData,
                            }];
                }
            });
        }); };
        this.update = function (resource, params) { return __awaiter(_this, void 0, void 0, function () {
            var queryName, query, data, queryData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        queryName = this.getQueryName("update", resource);
                        query = this.getQuery(queryName);
                        data = params.data;
                        delete data._deleted;
                        delete data._lastChangedAt;
                        delete data.createdAt;
                        delete data.updatedAt;
                        return [4 /*yield*/, this.graphql(query, { input: data })];
                    case 1:
                        queryData = (_a.sent())[queryName];
                        return [2 /*return*/, {
                                data: queryData,
                            }];
                }
            });
        }); };
        // This may not work for API that uses DataStore because
        // DataStore works with a _version field that needs to be properly set
        this.updateMany = function (resource, params) { return __awaiter(_this, void 0, void 0, function () {
            var queryName, query, data, ids, _i, _a, id, e_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        queryName = this.getQueryName("update", resource);
                        query = this.getQuery(queryName);
                        data = params.data;
                        delete data._deleted;
                        delete data._lastChangedAt;
                        delete data.createdAt;
                        delete data.updatedAt;
                        ids = [];
                        _i = 0, _a = params.ids;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 6];
                        id = _a[_i];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this.graphql(query, { input: __assign(__assign({}, data), { id: id }) })];
                    case 3:
                        _b.sent();
                        ids.push(id);
                        return [3 /*break*/, 5];
                    case 4:
                        e_2 = _b.sent();
                        console.log(e_2);
                        return [3 /*break*/, 5];
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/, {
                            data: ids,
                        }];
                }
            });
        }); };
        this.delete = function (resource, params) { return __awaiter(_this, void 0, void 0, function () {
            var queryName, query, id, previousData, data, queryData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        queryName = this.getQueryName("delete", resource);
                        query = this.getQuery(queryName);
                        id = params.id, previousData = params.previousData;
                        data = { id: id };
                        if (previousData._version) {
                            data._version = previousData._version;
                        }
                        return [4 /*yield*/, this.graphql(query, { input: data })];
                    case 1:
                        queryData = (_a.sent())[queryName];
                        return [2 /*return*/, {
                                data: queryData,
                            }];
                }
            });
        }); };
        this.deleteMany = function (resource, params) { return __awaiter(_this, void 0, void 0, function () {
            var queryName, query, ids, _i, _a, id, e_3;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        queryName = this.getQueryName("delete", resource);
                        query = this.getQuery(queryName);
                        ids = [];
                        _i = 0, _a = params.ids;
                        _b.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 6];
                        id = _a[_i];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, this.graphql(query, { input: { id: id } })];
                    case 3:
                        _b.sent();
                        ids.push(id);
                        return [3 /*break*/, 5];
                    case 4:
                        e_3 = _b.sent();
                        console.log(e_3);
                        return [3 /*break*/, 5];
                    case 5:
                        _i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/, {
                            data: ids,
                        }];
                }
            });
        }); };
        this.queries = operations.queries;
        this.mutations = operations.mutations;
        this.authMode = (options === null || options === void 0 ? void 0 : options.authMode) || defaultOptions.authMode;
        this.enableAdminQueries =
            (options === null || options === void 0 ? void 0 : options.enableAdminQueries) || defaultOptions.enableAdminQueries;
        DataProvider.storageBucket = options === null || options === void 0 ? void 0 : options.storageBucket;
        DataProvider.storageRegion = options === null || options === void 0 ? void 0 : options.storageRegion;
    }
    DataProvider.prototype.getQuery = function (queryName) {
        if (this.queries[queryName]) {
            return this.queries[queryName];
        }
        if (this.mutations[queryName]) {
            return this.mutations[queryName];
        }
        console.log("Could not find query " + queryName);
        throw new Error("Data provider error");
    };
    DataProvider.prototype.getQueryName = function (operation, resource) {
        var pluralOperations = ["list"];
        if (pluralOperations.includes(operation)) {
            return "" + operation + (resource.charAt(0).toUpperCase() + resource.slice(1));
        }
        // else singular operations ["create", "delete", "get", "update"]
        return "" + operation + (resource.charAt(0).toUpperCase() + resource.slice(1, -1));
    };
    DataProvider.prototype.getQueryNameMany = function (operation, resource, target) {
        var queryName = this.getQueryName(operation, resource);
        return queryName + "By" + (target.charAt(0).toUpperCase() + target.slice(1, -2)) + "Id";
    };
    DataProvider.prototype.graphql = function (query, variables) {
        return __awaiter(this, void 0, void 0, function () {
            var queryResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, api.API.graphql({
                            query: query,
                            variables: variables,
                            authMode: this.authMode,
                        })];
                    case 1:
                        queryResult = _a.sent();
                        if (queryResult.errors || !queryResult.data) {
                            throw new Error("Data provider error");
                        }
                        return [2 /*return*/, queryResult.data];
                }
            });
        });
    };
    return DataProvider;
}());

function buildAuthProvider(options) {
    var authProvider = new AuthProvider(options);
    return {
        login: authProvider.login,
        logout: authProvider.logout,
        checkAuth: authProvider.checkAuth,
        checkError: authProvider.checkError,
        getPermissions: authProvider.getPermissions,
    };
}
function buildDataProvider(operations, options) {
    var dataProvider = new DataProvider(operations, options);
    return {
        getList: dataProvider.getList,
        getOne: dataProvider.getOne,
        getMany: dataProvider.getMany,
        getManyReference: dataProvider.getManyReference,
        create: dataProvider.create,
        update: dataProvider.update,
        updateMany: dataProvider.updateMany,
        delete: dataProvider.delete,
        deleteMany: dataProvider.deleteMany,
    };
}

var AmplifyAdmin = function (_a) {
    var children = _a.children, operations = _a.operations, options = _a.options, propsRest = __rest(_a, ["children", "operations", "options"]);
    var _b = options || {}, authGroups = _b.authGroups, authMode = _b.authMode, storageBucket = _b.storageBucket, storageRegion = _b.storageRegion, enableAdminQueries = _b.enableAdminQueries;
    return (React__default['default'].createElement(reactAdmin.Admin, __assign({}, propsRest, { authProvider: buildAuthProvider({ authGroups: authGroups }), dataProvider: buildDataProvider(operations, {
            authMode: authMode,
            storageBucket: storageBucket,
            storageRegion: storageRegion,
            enableAdminQueries: enableAdminQueries,
        }) }), children));
};

function useStorageField(_a) {
    var _this = this;
    var source = _a.source, _b = _a.record, record = _b === void 0 ? {} : _b, _c = _a.storageOptions, storageOptions = _c === void 0 ? {} : _c;
    var _d = React__default['default'].useState(null), fieldProps = _d[0], setFieldProps = _d[1];
    React__default['default'].useEffect(function () {
        function getUrl(key) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, storage.Storage.get(key, storageOptions)];
                        case 1: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        }
        // Case when using the field within an AmplifyInput
        if (!source) {
            if (!record.key) {
                return;
            }
            getUrl(record.key)
                .then(function (url) {
                if (typeof url !== "string") {
                    return;
                }
                var updatedRecord = __assign({}, record);
                updatedRecord._url = url;
                setFieldProps({
                    source: "_url",
                    record: updatedRecord,
                    title: record.key.split(/_(.+)/)[1],
                });
            })
                .catch(function () { });
            return;
        }
        if (!record[source]) {
            return;
        }
        // Case when using the field with an array of files
        if (Array.isArray(record[source])) {
            Promise.all(record[source].map(function (value) { return __awaiter(_this, void 0, void 0, function () {
                var url;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!value.key) {
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, getUrl(value.key)];
                        case 1:
                            url = _a.sent();
                            if (typeof url !== "string") {
                                return [2 /*return*/];
                            }
                            return [2 /*return*/, __assign(__assign({}, value), { _url: url, _title: value.key.split(/_(.+)/)[1] })];
                    }
                });
            }); }))
                .then(function (values) {
                var updatedRecord = __assign({}, record);
                updatedRecord[source] = values.filter(function (v) { return !!v; });
                setFieldProps({
                    source: source,
                    record: updatedRecord,
                    title: "_title",
                    src: "_url",
                });
            })
                .catch(function () { });
            return;
        }
        if (!record[source].key) {
            return;
        }
        // Default case when rendering a single file
        getUrl(record[source].key)
            .then(function (url) {
            if (typeof url !== "string") {
                return;
            }
            var updatedRecord = __assign({}, record);
            updatedRecord[source]._url = url;
            setFieldProps({
                source: source + "._url",
                record: updatedRecord,
                title: record[source].key.split(/_(.+)/)[1],
            });
        })
            .catch(function () { });
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [record.key]);
    return fieldProps;
}

var AmplifyFileField = function (_a) {
    var source = _a.source, _b = _a.record, record = _b === void 0 ? {} : _b, _c = _a.storageOptions, storageOptions = _c === void 0 ? {} : _c, props = __rest(_a, ["source", "record", "storageOptions"]);
    var fieldProps = useStorageField({ source: source, record: record, storageOptions: storageOptions });
    if (!fieldProps) {
        return null;
    }
    return React__default['default'].createElement(reactAdmin.FileField, __assign({}, fieldProps, props));
};

function useStorageInput(_a) {
    var source = _a.source, _b = _a.multiple, multiple = _b === void 0 ? false : _b, onDropAcceptedCallback = _a.onDropAcceptedCallback, _c = _a.storageOptions, storageOptions = _c === void 0 ? {} : _c;
    var input = reactAdmin.useInput({ source: source }).input;
    React__default['default'].useEffect(function () {
        if (Array.isArray(input.value) && input.value.length === 0) {
            input.onChange(undefined);
        }
    }, [input]);
    function onDropAccepted(files, event) {
        return __awaiter(this, void 0, void 0, function () {
            var values, e_1;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, Promise.all(files.map(function (file) { return __awaiter(_this, void 0, void 0, function () {
                                var result;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, storage.Storage.put(uuid.v4().replace(/-/g, "") + "_" + file.name, file, storageOptions)];
                                        case 1:
                                            result = (_a.sent());
                                            return [2 /*return*/, {
                                                    bucket: DataProvider.storageBucket,
                                                    region: DataProvider.storageRegion,
                                                    key: result.key,
                                                }];
                                    }
                                });
                            }); }))];
                    case 1:
                        values = _a.sent();
                        if (!multiple) {
                            input.onChange(values[0]);
                            return [2 /*return*/];
                        }
                        if (input.value) {
                            input.onChange(__spreadArray(__spreadArray([], input.value), values));
                        }
                        else {
                            input.onChange(values);
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        e_1 = _a.sent();
                        console.log(e_1);
                        input.onChange(undefined);
                        return [3 /*break*/, 3];
                    case 3:
                        if (onDropAcceptedCallback) {
                            onDropAcceptedCallback(files, event);
                        }
                        return [2 /*return*/];
                }
            });
        });
    }
    return { onDropAccepted: onDropAccepted };
}

var AmplifyFileInput = function (_a) {
    var _b = _a.options, options = _b === void 0 ? {} : _b, _c = _a.storageOptions, storageOptions = _c === void 0 ? {} : _c, props = __rest(_a, ["options", "storageOptions"]);
    var onDropAccepted = useStorageInput({
        source: props.source,
        multiple: props.multiple,
        onDropAcceptedCallback: options.onDropAccepted,
        storageOptions: storageOptions,
    }).onDropAccepted;
    return (React__default['default'].createElement(reactAdmin.FileInput, __assign({}, props, { options: __assign(__assign({}, options), { onDropAccepted: onDropAccepted }) }),
        React__default['default'].createElement(AmplifyFileField, { storageOptions: storageOptions })));
};

// Extracts hash and sort keys from source props
function getKeys(filters) {
    var keys = {};
    for (var _i = 0, filters_1 = filters; _i < filters_1.length; _i++) {
        var filter = filters_1[_i];
        if (filter === null || typeof filter !== "object") {
            throw new Error("AmplifyFilter children are invalid");
        }
        var input = filter;
        if (!input.props || !input.props.source) {
            throw new Error("AmplifyFilter children are invalid");
        }
        var source = input.props.source;
        var sourceSplit = source.split(".");
        // A dot must seperate the query name and the key name
        if (sourceSplit.length < 2) {
            throw new Error("Source " + source + " is not valid because a separation dot is missing");
        }
        var queryName = sourceSplit[0];
        var keyName = sourceSplit[1];
        if (!keys[queryName]) {
            keys[queryName] = {
                hashKey: "",
                sortKey: "",
            };
        }
        // Case when there is only the hash key
        if (sourceSplit.length === 2) {
            if (keys[queryName].hashKey !== "") {
                throw new Error("Source " + source + " is not valid because hash key is already defined by another input");
            }
            keys[queryName].hashKey = keyName;
            continue;
        }
        keys[queryName].sortKey = keyName;
    }
    return keys;
}
var AmplifyFilter = function (_a) {
    var children = _a.children, defaultQuery = _a.defaultQuery, _b = _a.setQuery, setQuery = _b === void 0 ? null : _b, propsRest = __rest(_a, ["children", "defaultQuery", "setQuery"]);
    var filters;
    if (children !== null && typeof children === "object") {
        filters = [children];
    }
    if (Array.isArray(children)) {
        filters = children;
    }
    if (!filters) {
        throw new Error("AmplifyFilter children are invalid");
    }
    // First checks if children source props are well formatted
    var keys = getKeys(filters);
    var rest = propsRest;
    var filterValues = rest.filterValues;
    var setFilters = rest.setFilters;
    // Determines which query will be executed depending on the filter
    var query = defaultQuery;
    if (Object.keys(filterValues).length === 1) {
        query = Object.keys(filterValues)[0];
        var filterHashKey = filterValues[query][keys[query].hashKey];
        // Case when filter values do not contain mandatory hash key
        if (!filterHashKey && setFilters) {
            setFilters({});
        }
    }
    // Tells the list component about the query in order to know which fields are sortable
    React.useEffect(function () {
        setQuery && setQuery(query);
    }, [query, setQuery]);
    function showFilter(queryName) {
        return query === defaultQuery || query === queryName;
    }
    // Checks if filter has a value
    function notBlank(filter) {
        return !!filter.split(".").reduce(function (o, i) { return (!o ? o : o[i]); }, filterValues);
    }
    function renderInput(filter) {
        var input = filter;
        var source = input.props.source;
        var sourceSplit = source.split(".");
        var queryName = sourceSplit[0];
        if (sourceSplit.length === 2) {
            return showFilter(queryName) && input;
        }
        var hashKeySource = queryName + "." + keys[queryName].hashKey;
        return showFilter(queryName) && notBlank(hashKeySource) && input;
    }
    return React__default['default'].createElement(reactAdmin.Filter, __assign({}, rest), filters.map(renderInput));
};

var AmplifyImageField = function (_a) {
    var source = _a.source, _b = _a.record, record = _b === void 0 ? {} : _b, _c = _a.storageOptions, storageOptions = _c === void 0 ? {} : _c, props = __rest(_a, ["source", "record", "storageOptions"]);
    var fieldProps = useStorageField({ source: source, record: record, storageOptions: storageOptions });
    if (!fieldProps) {
        return null;
    }
    return React__default['default'].createElement(reactAdmin.ImageField, __assign({}, fieldProps, props));
};

var AmplifyImageInput = function (_a) {
    var _b = _a.options, options = _b === void 0 ? {} : _b, _c = _a.storageOptions, storageOptions = _c === void 0 ? {} : _c, props = __rest(_a, ["options", "storageOptions"]);
    var onDropAccepted = useStorageInput({
        source: props.source,
        multiple: props.multiple,
        onDropAcceptedCallback: options.onDropAccepted,
        storageOptions: storageOptions,
    }).onDropAccepted;
    return (React__default['default'].createElement(reactAdmin.ImageInput, __assign({}, props, { options: __assign(__assign({}, options), { onDropAccepted: onDropAccepted }) }),
        React__default['default'].createElement(AmplifyImageField, { storageOptions: storageOptions })));
};

var CognitoGroupList = function (props) { return (React__default['default'].createElement(reactAdmin.List, __assign({}, props, { title: "Cognito Groups", bulkActionButtons: false }),
    React__default['default'].createElement(reactAdmin.Datagrid, null,
        React__default['default'].createElement(reactAdmin.TextField, { source: "id", label: "Group name", sortable: false }),
        React__default['default'].createElement(reactAdmin.TextField, { source: "UserPoolId", sortable: false }),
        React__default['default'].createElement(reactAdmin.TextField, { source: "Description", sortable: false }),
        React__default['default'].createElement(reactAdmin.TextField, { source: "RoleArn", label: "Role ARN", sortable: false }),
        React__default['default'].createElement(reactAdmin.NumberField, { source: "Precedence", sortable: false }),
        React__default['default'].createElement(reactAdmin.DateField, { source: "LastModifiedDate", sortable: false }),
        React__default['default'].createElement(reactAdmin.DateField, { source: "CreationDate", sortable: false })))); };

var CognitoUserFilter = function (props) { return (React__default['default'].createElement(AmplifyFilter, __assign({}, props),
    React__default['default'].createElement(reactAdmin.TextInput, { source: "getUser.username", label: "Username", alwaysOn: true, resettable: true }),
    React__default['default'].createElement(reactAdmin.TextInput, { source: "listUsersInGroup.groupname", label: "Group", alwaysOn: true, resettable: true }))); };
var CognitoUserList = function (props) { return (React__default['default'].createElement(reactAdmin.List, __assign({ title: "Cognito Users", filters: React__default['default'].createElement(CognitoUserFilter, null), bulkActionButtons: false }, props),
    React__default['default'].createElement(reactAdmin.Datagrid, null,
        React__default['default'].createElement(reactAdmin.TextField, { source: "id", label: "Username", sortable: false }),
        React__default['default'].createElement(reactAdmin.BooleanField, { source: "Enabled", sortable: false }),
        React__default['default'].createElement(reactAdmin.TextField, { source: "UserStatus", sortable: false }),
        React__default['default'].createElement(reactAdmin.TextField, { source: "email_verified", sortable: false }),
        React__default['default'].createElement(reactAdmin.TextField, { source: "phone_number_verified", sortable: false }),
        React__default['default'].createElement(reactAdmin.DateField, { source: "UserLastModifiedDate", sortable: false }),
        React__default['default'].createElement(reactAdmin.DateField, { source: "UserCreateDate", sortable: false }),
        React__default['default'].createElement(reactAdmin.ShowButton, null)))); };
var CognitoUserShowTitle = function (_a) {
    var record = _a.record;
    return (React__default['default'].createElement("span", null,
        "Cognito User",
        record ? " #" + record.id : ""));
};
var CognitoUserShow = function (props) {
    var record = reactAdmin.useShowController(props).record;
    if (!record) {
        return null;
    }
    record.id; record.Enabled; record.UserStatus; record.UserLastModifiedDate; record.UserCreateDate; var attributes = __rest(record, ["id", "Enabled", "UserStatus", "UserLastModifiedDate", "UserCreateDate"]);
    return (React__default['default'].createElement(reactAdmin.Show, __assign({ title: React__default['default'].createElement(CognitoUserShowTitle, null) }, props),
        React__default['default'].createElement(reactAdmin.SimpleShowLayout, null,
            React__default['default'].createElement(reactAdmin.TextField, { source: "id", label: "Username" }),
            React__default['default'].createElement(reactAdmin.ReferenceManyField, { reference: "cognitoGroups", target: "listGroupsForUser.username", label: "Groups" },
                React__default['default'].createElement(reactAdmin.SingleFieldList, { linkType: false },
                    React__default['default'].createElement(reactAdmin.ChipField, { source: "id" }))),
            React__default['default'].createElement(reactAdmin.BooleanField, { source: "Enabled" }),
            React__default['default'].createElement(reactAdmin.TextField, { source: "UserStatus" }),
            Object.keys(attributes).map(function (attribute) { return (React__default['default'].createElement(reactAdmin.TextField, { key: attribute, record: record, source: attribute })); }),
            React__default['default'].createElement(reactAdmin.DateField, { source: "UserLastModifiedDate" }),
            React__default['default'].createElement(reactAdmin.DateField, { source: "UserCreateDate" }))));
};

exports.AmplifyAdmin = AmplifyAdmin;
exports.AmplifyFileField = AmplifyFileField;
exports.AmplifyFileInput = AmplifyFileInput;
exports.AmplifyFilter = AmplifyFilter;
exports.AmplifyImageField = AmplifyImageField;
exports.AmplifyImageInput = AmplifyImageInput;
exports.CognitoGroupList = CognitoGroupList;
exports.CognitoUserFilter = CognitoUserFilter;
exports.CognitoUserList = CognitoUserList;
exports.CognitoUserShow = CognitoUserShow;
exports.CognitoUserShowTitle = CognitoUserShowTitle;
exports.buildAuthProvider = buildAuthProvider;
exports.buildDataProvider = buildDataProvider;
//# sourceMappingURL=index.js.map
